#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include rms
#include ssdef
#include descrip
#include ctype
#include stat
#include <starlet.h>

#include "lh.h"

#define	TRUE	1
#define	FALSE	0
#define	EOS	0

typedef struct rmsstuff {
	struct	RAB	rab;		/* Record access buffer		*/
	struct	FAB	fab;		/* File access buffer		*/
	struct	NAM	nam;		/* File name buffer		*/
	struct	XABFHC	xab;		/* Extended attributes block	*/
	short int	lrecl;		/* Logical record length	*/
	char 		flag;		/* wild file open status	*/
	char		binary;		/* TRUE if "rn" mode		*/
	char		vfc[2];		/* Printfile header field	*/
	char		starname[NAM$C_MAXRSS + 1]; /* Wild file name	*/
	char		filename[NAM$C_MAXRSS + 1]; /* Open file name	*/
	char		*rbuffer;	/* Record input buffer		*/
} RMSSTUFF;

#define	ISWILD		0
#define	UNWILD		1
#define	OPENED		2

int		rms_status;		/* Set to last rms call status	*/

int rms_getname(RMSSTUFF *r, char *buffer);

find_files (name, v_filec, v_filev)
char	*name;
int	*v_filec;
char	***v_filev;
{
    char	newname[256];
    char	**filev;
    int		filec = 0;
    RMSSTUFF	*r, *rms_fwild();
    char *rms_fnext();
    int alloc_size = 64;
    unsigned short	rfa[3];

    r = rms_fwild(name, "r");
    if (r == NULL) {
        return(0);
    }
    filev = (char**)malloc (alloc_size * sizeof(char *));
    for (filec = 0; rms_fnext(r) != NULL; ) {
	rms_getname(r, newname);
        filev[filec++] = strdup(newname);
	if (filec == alloc_size) {
            alloc_size += 64;
            filev = (char**)realloc (filev, alloc_size * sizeof(char *));
	}
     }  
     *v_filev = filev;
     *v_filec = filec;
     return(1);
}


RMSSTUFF *
rms_fwild(filename, mode)
char		*filename;		/* What to open			*/
char		*mode;			/* Must be "r"			*/
/*
 * Setup fwild.  Returns NULL on failure, else a pointer to RMS stuff.
 * Which is equivalently a pointer to the RAB. (Note that the RAB points
 * in turn to the FAB.)
 */
{
	register RMSSTUFF	*r;
	RMSSTUFF		*fail();

	if ((r = (RMSSTUFF *)malloc(sizeof (RMSSTUFF))) == NULL)
	    return (NULL);
	if (strcmp(mode, "r") == 0)
	    r->binary = FALSE;
	else if (strcmp(mode, "rn") == 0)
	    r->binary = TRUE;
	else return (NULL);
	/*
	 * Initialize the data blocks
	 */
	r->fab = cc$rms_fab;			/* Preset fab,		*/
	r->nam = cc$rms_nam;			/*   name block		*/
	r->rab = cc$rms_rab;			/*   and record block	*/
	r->xab = cc$rms_xabfhc;			/*   file header block	*/
	r->rbuffer = NULL;			/* No record buffer yet	*/
	/*
	 * Stuff the fab
	 */
	r->fab.fab$l_nam = &r->nam;		/* fab -> name block	*/
	r->fab.fab$l_xab = (char *)&r->xab;	/* fab -> file header	*/
	r->fab.fab$l_fna = filename;		/* Argument filename	*/
	r->fab.fab$b_fns = strlen(filename);	/* ... size		*/
	/*
	 * Point the rab at the fab
	 */
	r->rab.rab$l_fab = &r->fab;		/* rab -> fab		*/
	/*
	 * Stuff the name block
	 */
	r->nam.nam$l_esa = r->starname;		/* Expanded filename	*/
	r->nam.nam$b_ess = NAM$C_MAXRSS;	/* ... size		*/
	r->nam.nam$l_rsa = r->filename;		/* Result filename	*/
	r->nam.nam$b_rss = NAM$C_MAXRSS;	/* ... max size		*/
	/*
	 * Parse the file name
	 */
	if ((rms_status = sys$parse(&r->fab)) != RMS$_NORMAL) {
	    return (fail(r, "parsing", filename));
	}
	/*
	 * Success -- null terminate expanded file name
	 * and set flag to ISWILD for non-wildcard calls.
	 */
	((char *)r->nam.nam$l_esa)[r->nam.nam$b_esl] = EOS;
	r->flag = ((r->nam.nam$l_fnb & NAM$M_WILDCARD) == 0) ? UNWILD : ISWILD;
	return (r);
}


char *
rms_fnext(r)
register RMSSTUFF	*r;
/*
 * Open the next valid file. return fd if successful, NULL if finished.
 */
{
	RMSSTUFF		*fail();

	if ((r->flag & OPENED) != 0) {
	    /*
	     * A file was opened, close it for next go-around.
	     */
	    free(r->rbuffer);
	    r->rbuffer = NULL;
	    if ((rms_status = sys$close(&r->fab)) != RMS$_NORMAL) {
		return((char *)fail(r, "closing", NULL));
	    }
	}

next_one:
	switch (r->flag) {
	case (UNWILD | OPENED):
	    /*
	     * It wasn't a wildcard and has already been processed
	     */
	    free (r);			/* Take normal exit instead	*/
	    return (NULL);

	case UNWILD:
	    /*
	     * Not a wildcard file, first time through
	     */
	    r->fab.fab$l_fna = r->nam.nam$l_esa;	/* File name	*/
	    r->fab.fab$b_fns = r->nam.nam$b_esl;	/* Length	*/
	    break;			/* Go open it			*/

	case ISWILD:
	case (ISWILD | OPENED):
	    /*
	     * Look for the next match -- who says you can't write
	     * obscure structured code?
	     */
	    for (;;) {
		/*
		 * Look 'em up but skip any with protection violation errors.
		 */
		r->fab.fab$w_ifi = 0;
		if ((rms_status = sys$search(&r->fab)) & 1) {
		    /*
		     * Gotcha?
		     */
		    ((char *)r->nam.nam$l_rsa)[r->nam.nam$b_rsl] = EOS;
		    /*
		     * Found the file, setup the name
		     * and length, and go open it.
		     */
		    r->fab.fab$l_fna = r->nam.nam$l_rsa;
		    r->fab.fab$b_fns = r->nam.nam$b_rsl;
		    break;		/* Found file, go open it	*/
					/* Else, continue searching	*/
		}
		else if (rms_status != RMS$_PRV) {
		    /*
		     * Normal completion
		     */
		    if (rms_status != RMS$_NMF) {
			/*
			 * Unexpected error searching
			 */
			return ((char *)fail(r, "searching", r->nam.nam$l_esa));
		    }
		    else {
			free(r);
			return (NULL);
		    }
		}
		else {
		    /*
		     * Privilege violation when searching, search another.
		     */
		}
	    }				/* Forever loop exit		*/
	    break;			/* switch exit			*/
	}
	/*
	 * We've found a file, try to open it.  If this fails, go back and
	 * try the next one.  (However, if there was nothing wild, don't
	 * go back - there's nothing more to do.)
	 */
	r->fab.fab$b_fac = FAB$M_GET;		/* Input only		*/
	r->fab.fab$l_fop |= FAB$M_NAM;		/* Use name block	*/
	((char *)r->fab.fab$l_fna)[r->fab.fab$b_fns] = EOS;
	if (((rms_status = sys$open(&r->fab)) & 1) == 0) {
	    if (r->flag & UNWILD)
		return (NULL);			/* Nothing more to try	*/
	    goto next_one;			/* Wild - try again	*/
	}

	/*
	 * Normal exit -- set vfc area.
	 */
	r->flag |= OPENED;
	if ((r->fab.fab$b_rat & ~FAB$M_BLK) == FAB$M_PRN) {
	    if ((r->fab.fab$b_rfm != FAB$C_VFC || r->fab.fab$b_fsz != 2))
		return ((char *)fail(r, "printfile bad printfile", NULL));
	    r->rab.rab$l_rhb = (char *)&r->vfc;
	}
	r->rab.rab$w_usz = (r->fab.fab$w_mrs > r->xab.xab$w_lrl)
	    ? r->fab.fab$w_mrs : r->xab.xab$w_lrl;
	if (r->fab.fab$b_rfm == FAB$C_VFC)	/* Even more bytes if	*/
	    r->rab.rab$w_usz += r->fab.fab$b_fsz; /* fixed control area	*/
	if (r->rab.rab$w_usz < 1024)		/* Just in case (for	*/
	    r->rab.rab$w_usz = 1024;		/* STREAM_LF files)	*/
	if ((rms_status = sys$connect(&r->rab)) != RMS$_NORMAL)
	    return ((char *)fail(r, "connecting", NULL));
	if ((r->rbuffer = (char *)malloc(r->rab.rab$w_usz)) == NULL)
	    return ((char *)fail(r, "allocating record buffer for", NULL));
	r->rab.rab$l_ubf = r->rbuffer;
	return ((char *)r);
}



rms_getname(r, buffer)
RMSSTUFF	*r;			/* File pointer			*/
char		*buffer;		/* Where to put it		*/
/*
 * Return current file name
 */
{
	strcpy(buffer, r->fab.fab$l_fna);
	return ((int)buffer);
}


RMSSTUFF *
fail(r, why, name)
RMSSTUFF	*r;			/* Buffer			*/
char		*why;			/* A little commentary		*/
char		*name;			/* Argument to perror		*/
/*
 * Problem exit routine
 */
{
	if (r->rbuffer != NULL)
	    free (r->rbuffer);
	free(r);
	return (NULL);
}

/*
utime(name,val)
{
        return(0);
}
*/

popen() { return(1); }
pclose() { return(1); }


/*
 * translate DISK$XYZ:[FOO.BAR]FILE.EXT; to   BAR/FILE.EXT
 * if current dir is [FOO] if current dir is [FOO.BAR] then just FILE.EXT
 */ 
char *
vms_to_unix_file_name(name,cwd_relative)
char *name;
{
    static char sname[128],*p,*cp;
    char curdir[256], *getcwd();
    int endofdir = 0;
    if (strchr(name,'/'))       /* already is unix file name format */
        return(name);

    /*
     * if current working directory relative, then ignore current
     * and parent path in the archive spec.
     */
    if (cwd_relative) {    
        cp = getcwd(curdir,sizeof curdir);
        while(*name && *name == *cp) {
            if (*name == ']') 
                break;
            ++name;
            ++cp;
        }
    }

    /* 
     * skip by device or node 
     */
    if (p = strrchr(name,':')) {
        name = p+1;
    }
    if (*name != '.') {
        while (*name == '[' || *name == '.' || *name == ']' ) {
            if (*name == ']')
                endofdir = 1;
            ++name;
        }
    }
    /*
     * either passed end of dir spec or this filename contains no
     * path
     */
    if (strchr(name,']') == NULL) {
        endofdir = 1;
    }
    strcpy(sname,name);
    /*
     * zap version number
     */
    if (p = strchr(sname,';'))
        *p = '\0';
        
    if (endofdir == 0) {
        for(p = sname; *p; ++p) {
            if (*p == ']') {
                *p = '/';
                break;
            }
            else if (*p == '.') *p = '/';
        }
    }
    return(sname);
}

/*
 * check if Variable length records, we need to read through the
 * file to find out how big it really is.
 */
vms_file_size(name,v_stat)
char *name;
struct stat *v_stat;
{
     int n, size = 0;
     char buf[4096];
     FILE *ifp;
     
     if (v_stat->st_fab_rfm != FAB$C_VAR) {
        return(v_stat->st_size);
     }
     if ((ifp = fopen(name,"r"))  == NULL)  {
        error(name);
        return(0);
     }
     while(n = fread (buf, sizeof (char), sizeof buf, ifp)) { 
        size += n;
     }     
     fclose(ifp);
     return(size);
}

vms_filter(p)
char *p;
{
    int dot = 0;

    while (*p) {
	if (!(isalnum(*p) || (*p == '.' && dot++ == 0) ||
	      *p == '$' || *p == '-' || *p == '/')) {
	    *p = '_';
	}
	++p;
    }
}

/*
 * replace dir/dir/dir/file.ext
 * with    [.dir.dir.dir]file.ext
 */
char *
unix_to_vms_file_name(uname)
char *uname;
{
    static char vname[256];
    char *p;
    
    strcpy(vname,"[.");
    strcat(vname,uname);
    if (p = strrchr(vname,'/')) {
        *p = ']';
        while(p > vname) {
            if (*p == '/') *p = '.';
            --p;
        }
        return(vname);
    }
    return(&vname[2]);
}
