/*
 * Wild card comparison routines.
 *
 * Steve Drew 1990.
 */

#include <stdio.h>
#ifdef  unix
#include <strings.h>
#endif
#ifndef unix
#define IGNORECASE 
#endif
#ifdef vms
#include <string.h>
#include <ctype.h>
#endif

int match_half (register char *string,register char *pattern);

/*
 * compare two unix style path/file names for match.
 */
wildcmp(file,pattern)
char *file,*pattern;
{
    char *pat,*p;
    char tmp[256];

    pat = pattern;
    /*
     * if pat does not contain file name then add '*'
     */
    if (pattern[strlen(pattern)-1] == '/') {
        strcpy(tmp,pattern);
        strcat(tmp,"*");
        pat = tmp;
    }

#ifdef vms
    /*
     * if a vms spec of [*...] is specified will be here with 
     * dir//// so get rid of all path info from pat and file spec.
     */
    if (strncmp(pat,"*////",5) == 0) {
        p = strrchr(file,'/');
        if (p == NULL) p = file;
        else p++;
        return( match_half(p, strrchr(pat,'/')+1) );
    }
    /*
     * must of been [dir...] or [dir.dir*...] will now be
     * dir/ or dir/dir* /.
     */
    if (p = strstr(pat,"////")) {
        strcpy(p,p+3);
    }
    /*
     * if []file.ext spec replace with file.ext
     */
    if (strncmp(pat,"[]",2) == 0) {
        strcpy(pat,pat+2);
    }
#endif
    /*
     * if pat does not contain path, then only compare against filename
     * (this is what zoo does, but I'm not sure if I like that. since
     * zoo x archive readme - gets multiple files.)
     *
    if (strchr(pat,'/') == NULL) {
        if (p = strrchr(file,'/')) {
            return(match_half(p+1,pat));
        }
    }
    */

    return(match_half(file,pat));
}

/*
 * match_half() compares a pattern with a string.  Wildcards accepted in
 * the pattern are:  "*" for zero or more arbitrary characters;  "?"
 * for any one characters.  Unlike the MS-DOS wildcard match, "*" is
 * correctly handled even if it isn't at the end of the pattern. ".'
 * is not special.
 *  Originally written by Jeff Damens of Columbia University Center for
 *  Computing Activities.  Taken from the source code for C-Kermit version
 *  4C.
 *      (returns zero on match)
 */
int match_half (string, pattern) 
register char *string, *pattern;
{
   char *psave,*ssave;        /* back up pointers for failure */
   psave = ssave = NULL;

   /* printf("file = %s, pattern = %s\n",string,pattern); */
   while (1) {
#ifdef IGNORECASE
      for (; 
         tolower(*pattern) == tolower(*string); 
         pattern++,string++                        )  /* skip first */
#else
      for (; *pattern == *string; pattern++,string++)  /* skip first */
#endif /* IGNORECASE */
         if (*string == '\0') 
            return(0);                          /* end of strings, succeed */
      if (*string != '\0' && *pattern == '?') {
         pattern++;                             /* '?', let it match */
         string++;
      } else if (*pattern == '*') {             /* '*' ... */
         psave = ++pattern;                     /* remember where we saw it */
         ssave = string;                        /* let it match 0 chars */
      } else if (ssave != NULL && *ssave != '\0') {   /* if not at end  */
         /* ...have seen a star */
         string = ++ssave;                      /* skip 1 char from string */
         pattern = psave;                       /* and back up pattern */
      } else 
         break;                                  /* otherwise just fail */
   }
#ifdef IGNORECASE
   return(tolower(*string) - tolower(*pattern));
#else
   return(*string - *pattern);
#endif
}

